' Lawson Labs, Inc.                   Model 202 24-Bit Delta-Sigma Converter
' 74 4th Ave. NW                            Scanning Mode Demonstration Code
' Kalispell, MT  59901
' 800 321-5355 or 406 257-5355                      October 30, 1995  Rev B

  DIM CC%(5): DIM CHAN%(5)   'read configuration for current directory
  CLS : ON ERROR GOTO READERR: OPEN "DRIVR202.CFG" FOR INPUT AS #2
  INPUT #2, MODEREGHI%, MODEREGMID%, MODEREGLO%, CHANNEL%, FILTER%, AVERAGE%
  INPUT #2, DACENABLE%, BAUD%, COM$, INPBUF%, NUMAVG, BU%, GAIN%, RATE, WL%
  INPUT #2, CHAN%(0), CHAN%(1), CHAN%(2), CHAN%(3), CHAN%(4), CHAN%(5)
  INPUT #2, SINGLECHAN%
  INPUT #2, SCAN%, SCAN1%, SCAN2%, SCANINTERVAL#, STYPE%, RESERVE%
  CLOSE : ON ERROR GOTO 0
  IF WL% = 0 THEN WORDCNT% = 2 ELSE WORDCNT% = 3
  MODEREGHI% = MODEREGHI% AND &HFE 'clear powerdown bit
  NUMCCS% = 0
  TIMEBASECNT = 10000: COUNTSPERVOLT = TIMEBASECNT / 5
  TIMEBASE% = 0: ANALOGOUTA% = 1: ANALOGOUTB% = 2
  FOR N = 0 TO 5     'initialize control code array
    CC%(N) = CHAN%(N) MOD 16 - INT(CHAN%(N) / 16) + 1
    NUMCCS% = NUMCCS% + CC%(N)  'figure total number of channels/scan
  NEXT N
  A$ = "": OPEN COM$ + "300,N,8,1,BIN,RS,CS,DS,CD,RB" FOR RANDOM AS #1
  CLS : LOCATE 10, 30: PRINT "Signing on": OUTBYTE% = &H0: WAKEUPCALLS = 0
  ON ERROR GOTO 1000
WAKEUP1:                           'sign-on
  WAKEUPCALLS = WAKEUPCALLS + 1
  IF WAKEUPCALLS = 40 THEN PRINT "can't wake": END
  OUT$ = CHR$(OUTBYTE%): PRINT #1, OUT$; : XX = .2: GOSUB WAITXX
EMPTYBUFFER:            'empty the serial input buffer
  IF LOC(1) <> 0 THEN GOSUB GETCHAR: GOTO EMPTYBUFFER
  IF INPBYTE% <> 3 THEN XX = .2: GOSUB WAITXX: GOTO WAKEUP1
  OUT$ = CHR$(&H88): PRINT #1, OUT$; : XX = .1: GOSUB WAITXX 'sign-on token
  OUT$ = CHR$(BAUD%): PRINT #1, OUT$;   'send baud rate from config. file
  WAITIME = 1: NUMCHARS% = 1: GOSUB WAITCHAR: GOSUB GETCHAR
  IF INPBYTE% <> BAUD% THEN GOTO WAKEUP1  'if baud not echoed then try again
  CLOSE : BAUDRT% = 9600 / 2 ^ BAUD%      'set baud rate
  S$ = COM$ + STR$(BAUDRT%) + ",N,8,1,BIN,RS,CS,DS,CD,RB" + STR$(INPBUF%)
  OPEN S$ FOR RANDOM AS #1                're-open COM port at baud
  XX = .1: GOSUB WAITXX         'wait .1 sec for power supply
  OUT$ = CHR$(&H0): PRINT #1, OUT$;       'send end echo command
  GOSUB SETMODE                           'send A/D registers
  OUTB1% = AVERAGE%: OUTB2% = FILTER%: GOSUB sendpacket 'send avg. and filt.
  OUTB2% = 0: GOSUB sendpacket: GOSUB READMODE  'set 0 for scanning mode
  OUTB1% = SCAN%: OUTB2% = SCAN1%: GOSUB sendpacket   'send scan interval
  OUTB1% = SCAN2%: OUTB2% = CHAN%(0): GOSUB sendpacket ' and channel codes
  OUTB1% = CHAN%(1): OUTB2% = CHAN%(2): GOSUB sendpacket
  OUTB1% = CHAN%(3): OUTB2% = CHAN%(4): GOSUB sendpacket
  OUTB1% = CHAN%(5): OUTB2% = 0: GOSUB sendpacket
  GOSUB INITCOUNTERS
  WAITIME = (NUMAVG / RATE) + BAUD% / 10 + 2  'calculate conversion wait time
  SCANWORDS = NUMCCS% * WORDCNT% + 2
  IF STYPE <> 2 THEN GOSUB SYSCAL
  OUTB1% = &H89   'normal scan command token (&H8C for cal scan)
  IF STYPE% = 2 THEN SCANWORDS = SCANWORDS + (WORDCNT% * 2): OUTB1% = &H8C
  IF STYPE% = 0 THEN 'if singlechannel, select channel and wait settling time
    SCANWORDS = WORDCNT%: OUTB1% = &H1: OUTB2% = SINGLECHAN%: GOSUB sendpacket
    XX = FTIME * 2 + .5: GOSUB WAITXX    ' wait settling time
    OUTB1% = &H8B    '&H8B is single chan. token. Next figure screen location
    CC = (SINGLECHAN% MOD 16) + 3: N = INT(SINGLECHAN% / 16) * 13 + 4
  END IF
  GOSUB sendpacket          ' send start scan command
  NUMCHARS% = 1: GOSUB WAITCHAR: GOSUB GETCHAR  'get echoed start scan token
  IF INPBYTE% <> OUTB1% THEN PRINT "Scan start failure": END
SETDISPLAY:
  CLS : PRINT " CC     chan 0       chan 1       chan 2      ";
  PRINT " chan 3       chan 4       chan 5": PRINT
  FOR I = 0 TO 15: PRINT I: NEXT: NUMCHARS% = WORDCNT%  'now set up screen
  LOCATE 25, 2: PRINT "Wait                       Esc=end       Z=set DAC";
  LOCATE 24, 68: PRINT "Scan interval";
  LOCATE 25, 65: PRINT USING "#######.### secs"; SCANINTERVAL#;
SCANSTATUS:
  IF LOC(1) > (INPBUF% - 10) THEN PRINT "Buffer full": END
  A$ = INKEY$: IF A$ = CHR$(27) THEN END' escape to end
  IF A$ = "Z" THEN GOSUB ANALOGOUT: GOTO SETDISPLAY
  IF LOC(1) / SCANWORDS < 1 THEN GOTO SCANSTATUS ' wait for one scan
  SCANCNT = SCANCNT + 1
  LOCATE 25, 2: PRINT "SCAN #"; SCANCNT;
  IF STYPE% = 0 THEN LOCATE CC, N: GOSUB GCONV: GOTO SCANSTATUS
  GOSUB GETCHAR                       'should be start of scan token
  IF INPBYTE% <> &HF0 THEN PRINT "Scan framing failure": END
  IF STYPE% = 2 THEN
    GOSUB WAITCHAR: LOCATE 23, 1: PRINT "Offset cal "; : GOSUB GCONV
    GOSUB WAITCHAR: LOCATE 23, 25: PRINT "Full scale cal "; : GOSUB GCONV
  END IF
  FOR N = 0 TO 5   ' print data
    STARTCC = INT(CHAN%(N) / 16): ENDCC = CC%(N) + STARTCC - 1
      FOR CC = STARTCC TO ENDCC
        LOCATE (CC + 3), (N * 13) + 4: GOSUB GCONV
      NEXT CC
  NEXT N
  GOSUB GETCHAR                      ' should be end of scan token
  IF INPBYTE% <> &HF THEN PRINT "Scan framing failure": END
GOTO SCANSTATUS

SYSCAL: 'perform system calibration
  IF MODEREGHI% <> 0 THEN   'check for gain not equal to 1 before calibration
    ORGMD% = MODEREGHI%: MODEREGHI% = 0: GOSUB WARMSTART: MODEREGHI% = ORGMD%
  END IF  'if gain not equal to 1, save original gain and calibrate with 1
  CHANNEL% = 7: A$ = "O": GOSUB DOCAL   'offset cal.
  CHANNEL% = 6: A$ = "F": GOSUB DOCAL   'full-scale cal.
  IF MODEREGHI% <> 0 THEN GOSUB WARMSTART: CHANNEL% = 7: A$ = "O": GOSUB DOCAL
  XX = 4 / RATE: GOSUB WAITXX 'wait for 4 conversion cycles for A/D to settle
RETURN
 
DOCAL:  'perform individual calibration on channel selected
  GOSUB CLEARCOMMAND: OUTB2% = (CHANNEL% * 16) + EXTCCODE%
  ORGW = WAITIME: WAITIME = WAITIME + FTIME + 2
  IF A$ = "O" THEN OUTB1% = &H82: LOCATE 25, 27: PRINT "Offset Calibration";
  IF A$ = "F" THEN OUTB1% = &H83: LOCATE 25, 27: PRINT "Full scale Calibration";
  GOSUB sendpacket: NUMCHARS% = WORDCNT% + 1: GOSUB WAITCHAR
  FOR I = 1 TO WORDCNT% + 1: GOSUB GETCHAR: NEXT
  WAITIME = ORGW
RETURN

GCONV:  'get an A/D conversion, calculate count and scale in volts
  GOSUB GETCHAR: BYTE1# = INPBYTE%: GOSUB GETCHAR: BYTE2# = INPBYTE%
  IF WL% THEN GOSUB GETCHAR: BYTE3# = INPBYTE% ELSE BYTE3# = 0
  COUNT# = BYTE1# + BYTE2# * 256 + BYTE3# * 65536
  VOLTS = (COUNT# * .0000002980232#)
  IF WORDCNT% = 2 THEN VOLTS = VOLTS * 256
  IF BU% = 0 THEN VOLTS = VOLTS * 2 - 5
  PRINT USING "   ##.######"; VOLTS;
RETURN

GETCHAR:        ' fetch one byte from serial buffer
  IF LOC(1) <> 0 THEN INPBYTE% = ASC(INPUT$(1, #1)) ELSE INPBYTE% = 0
  CHECKSUM% = (CHECKSUM% + INPBYTE%) MOD 256
RETURN

sendpacket:       ' send command, argument & checksum
  PRINT #1, CHR$(OUTB1%); : PRINT #1, CHR$(OUTB2%);
  CHKSUM% = ((OUTB1% + OUTB2%) AND 255): PRINT #1, CHR$(CHKSUM%);
RETURN

SETMODE:  'send mode registers to Model 202
  OUTB1% = MODEREGHI%: OUTB2% = MODEREGMID%: GOSUB sendpacket
  OUTB1% = MODEREGLO%: GOSUB sendpacket
RETURN

WAITXX:              'wait xx seconds
  IF TIMER + XX > 86399 THEN GOTO WAITXX
  XX = TIMER + XX
WAITLOOP:
  IF TIMER < XX THEN GOTO WAITLOOP
RETURN

WAITCHAR:           'wait xx seconds for NUMCHARS% characters
  IF TIMER + WAITIME > 86399 THEN GOTO WAITCHAR
  XX = TIMER + WAITIME
HOLDON:
  IF LOC(1) >= NUMCHARS% THEN RETURN
  IF TIMER < XX THEN GOTO HOLDON ELSE PRINT " Serial port time-out": END
RETURN

WARMSTART:  're-start after mode change
  OUTB1% = &H84: GOSUB sendpacket: XX = .1: GOSUB WAITXX: GOSUB SETMODE
  NUMCHARS% = 1: GOSUB WAITCHAR: GOSUB GETCHAR
READMODE:   'verify mode registers were properly read
  NUMCHARS% = 3: GOSUB WAITCHAR: GOSUB GETCHAR
  IF (INPBYTE% AND &H1F) <> (MODEREGHI% AND &H1F) THEN BEEP
  GOSUB GETCHAR: IF INPBYTE% <> MODEREGMID% THEN BEEP
  GOSUB GETCHAR: IF INPBYTE% <> MODEREGLO% THEN BEEP
  ON ERROR GOTO 0
RETURN

CLEARCOMMAND:
  LOCATE 25, 1: PRINT SPACE$(80); : LOCATE 25, 57
RETURN

INITCOUNTERS:                                       ' initialize counters
  CNTPORT% = TIMEBASE%: CNTRCOUNT = TIMEBASECNT: GOSUB INITCNTR
  CNTPORT% = ANALOGOUTA%: CNTRCOUNT = TIMEBASECNT: GOSUB INITCNTR
  CNTPORT% = ANALOGOUTB%: CNTRCOUNT = 1: GOSUB INITCNTR
  DACAVOLTS = 0: DACBVOLTS = 5 / TIMEBASECNT
RETURN

INITCNTR:
  OUTB1% = 1: OUTB2% = DACENABLE% OR (CHANNEL% * 16) OR &H87 ' select mode reg
  GOSUB sendpacket
  OUTB1% = 7: IF CNTPORT% = 0 THEN CMODE% = 4 ELSE CMODE% = 2 'cntr 0 & mode 2
  OUTB2% = 48 + CNTPORT% * 64 + CMODE%: GOSUB sendpacket
WRITECNTR:
  CH = INT(CNTRCOUNT / 256): CL = FIX(CNTRCOUNT - CH * 256)
  OUTB1% = 1: OUTB2% = CNTPORT% OR 4 OR DACENABLE% OR (CHANNEL% * 16) OR &H80
  GOSUB sendpacket                               ' select counter number
  OUTB1% = 7: OUTB2% = CL: GOSUB sendpacket
  OUTB1% = 7: OUTB2% = CH: GOSUB sendpacket
  CMODE% = 1
RETURN

ANALOGOUT:                                      ' set analog output voltage
  CLS : LOCATE 10, 30: PRINT "DAC A          DAC B";
  LOCATE 12, 30: PRINT USING "#.####         "; DACAVOLTS; DACBVOLTS
  BUFILTIME = (INPBUF% - LOC(1) - 10) * SCANINTERVAL# / SCANWORDS
  LOCATE 18, 23: PRINT USING "###### seconds until buffer fills"; BUFILTIME
  LOCATE 20, 28: PRINT "DAC resolution = 1 /"; TIMEBASECNT;
  LOCATE 25, 18: PRINT "A for DAC A      B for DAC B      ESC to return";
GETDAC:
  CNT$ = UCASE$(INPUT$(1)): IF CNT$ = "" THEN GOTO GETDAC
  IF CNT$ = CHR$(27) THEN GOTO EXITANALOGOUT
  IF CNT$ <> "A" AND CNT$ <> "B" THEN GOTO GETDAC
ENTERV:
  CLS : LOCATE 10, 20: INPUT ; "Enter output voltage 0 - 5V ", VOLTAGE
  IF VOLTAGE < 0 OR VOLTAGE > 5 THEN GOTO ENTERV
  CNTRCOUNT = (VOLTAGE * COUNTSPERVOLT)                ' calculate counts
  'the dac A is inverted with respect to dac B
  IF CNT$ = "A" THEN CNTRCOUNT = TIMEBASECNT - CNTRCOUNT
  'don't exceed the max count
  IF (CNTRCOUNT > TIMEBASECNT) THEN CNTRCOUNT = TIMEBASECNT
  IF CNTRCOUNT < 1 THEN CNTRCOUNT = 1                  ' 0 is illegal count
  IF CNT$ = "A" THEN
    CNTPORT% = ANALOGOUTA%                            ' set counter address
    DACAVOLTS = (TIMEBASECNT - CNTRCOUNT) / COUNTSPERVOLT ' set last voltage
  ELSE
    CNTPORT% = ANALOGOUTB%                            ' set counter address
    DACBVOLTS = CNTRCOUNT / COUNTSPERVOLT             ' set last voltage
  END IF
  GOSUB WRITECNTR                                      ' set the voltage
  GOTO ANALOGOUT
EXITANALOGOUT:
CLS : RETURN

1000
  CLOSE #1
  OPEN COM$ + "300,N,8,1,BIN,RS,CS,DS,CD,RB" + STR$(INPBUF%) FOR RANDOM AS #1
  RESUME NEXT     ' ignore serial errors during sign-on

READERR:
  CLS : PRINT "Unable to read DRIVR202.CFG file ": END

